<template>
  <div class="login">
    <el-form ref="loginRef" :model="loginForm" :rules="loginRules" class="login-form">
      <h3 class="title">{{ title }}</h3>
      <el-form-item prop="username">
        <el-input
          v-model="loginForm.username"
          type="text"
          size="large"
          auto-complete="off"
          placeholder="账号"
        >
          <template #prefix><svg-icon icon-class="user" class="el-input__icon input-icon" /></template>
        </el-input>
      </el-form-item>
      <el-form-item prop="password">
        <el-input
          v-model="loginForm.password"
          type="password"
          size="large"
          auto-complete="off"
          placeholder="密码"
          @keyup.enter="handleLogin"
        >
          <template #prefix><svg-icon icon-class="password" class="el-input__icon input-icon" /></template>
        </el-input>
      </el-form-item>
      <!-- <el-form-item prop="code" v-if="captchaEnabled">
        <el-input
          v-model="loginForm.code"
          size="large"
          auto-complete="off"
          placeholder="验证码"
          style="width: 63%"
          @keyup.enter="handleLogin"
        >
          <template #prefix><svg-icon icon-class="validCode" class="el-input__icon input-icon" /></template>
        </el-input>
        <div class="login-code">
          <img :src="codeUrl" @click="getCode" class="login-code-img"/>
        </div>
      </el-form-item> -->
      <!-- <el-checkbox v-model="loginForm.rememberMe" style="margin:0px 0px 25px 0px;">记住密码</el-checkbox> -->
      <el-form-item style="width:100%;">
        <el-button
          :loading="loading"
          size="large"
          type="primary"
          style="width:100%;"
          @click.prevent="handleLogin"
        >
          <span v-if="!loading">登 录</span>
          <span v-else>登 录 中...</span>
        </el-button>
        <div style="float: right;" v-if="register">
          <router-link class="link-type" :to="'/register'">立即注册</router-link>
        </div>
      </el-form-item>
    </el-form>
    <!--  底部  -->
    <div class="el-login-footer">
      <span>Copyright © 2018-2025 All Rights Reserved.</span>
    </div>
  </div>
</template>

<script setup>
import { getCodeImg } from "@/api/login"
import Cookies from "js-cookie"
import { sm4 as SM4 } from 'gm-crypt' 
import { encrypt, decrypt } from "@/utils/jsencrypt"
import useUserStore from '@/store/modules/user'
import useAppStore from '@/store/modules/app'
import usePermissionStore from '@/store/modules/permission'
import { useRoute, useRouter } from 'vue-router'
const route = useRoute()
const router = useRouter()
const permissionStore = usePermissionStore()



const title = import.meta.env.VITE_APP_TITLE
const userStore = useUserStore()
const appStore = useAppStore()

const { proxy } = getCurrentInstance()

const loginForm = ref({
  username: "",
  password: "",
  rememberMe: false,
  code: "",
  uuid: ""
})

const loginRules = {
  username: [{ required: true, trigger: "blur", message: "请输入您的账号" }],
  password: [{ required: true, trigger: "blur", message: "请输入您的密码" }],
  code: [{ required: true, trigger: "change", message: "请输入验证码" }]
}

const codeUrl = ref("")
const loading = ref(false)
// 验证码开关
const captchaEnabled = ref(true)
// 注册开关
const register = ref(false)
const redirect = ref(undefined)

watch(route, (newRoute) => {
    redirect.value = newRoute.query && newRoute.query.redirect
}, { immediate: true })

function handleLogin() {
  proxy.$refs.loginRef.validate(valid => {
    if (valid) {
      loading.value = true

      userStore.login(loginForm.value).then(async (res) => {
        console.log('res123',res)
        let data = res

          let menus = transformRoutes(data.menus) 

          // return
          // 用户数据整理
          let user = data.tsysUser
          let loginBlankMenus = false
          if(data.menus.length === 0) {
            loginBlankMenus = true
          }
          
          try {
            await appStore.signOut('login')
            

           
            // console.log('menus',menus)
            // return

            let filterMenus = appStore.navStatus.type === 'manage' ? menus.filter(item => item.type === '1') : menus.filter(item => item.type === '2')
           
            appStore.setNav(filterMenus)
             
            appStore.setallNav(menus)
            console.log('appStore.nav',appStore.allnavList)
            // console.log('menus',filterMenus)
            appStore.setNavStatus({type: appStore.navStatus.type || 'manage'})
            // permissionStore.allsidebarRouters(menus)

            permissionStore.setSidebarRouters(filterMenus)
            // console.log('filterMenus',filterMenus)
            // 设置导航菜单
            // return
            
            // 设置用户信息
            appStore.setUserInfo({user, licenseRst: data.licenseRst, loginBlankMenus})
            
            // 存储token和登录信息
            window.sessionStorage.setItem('__token', data.token)
            const loginStr = JSON.stringify({
              username: loginForm.value.username,
              password: encryptPassword(loginForm.value.password)
            })
            window.sessionStorage.setItem('login', loginStr)
              const query = route.query
              const otherQueryParams = Object.keys(query).reduce((acc, cur) => {
                if (cur !== "redirect") {
                  acc[cur] = query[cur]
                }
                return acc
              }, {})
              // console.log('generateRoute', getRout)
          //  router.push({ path:"/index", query: otherQueryParams })
            router.push({ path: redirect.value || "/index", query: otherQueryParams })

            // if(redirect.value){
            //    console.log('redirect',redirect.value)
            //   router.push({ path: redirect.value, query: otherQueryParams })
            //        router.push({ path: redirect.value, query: otherQueryParams })
            //   console.log(2134)
            // }else{
            //   router.push({ path: "/", query: otherQueryParams })
            // }
            

            // console.log('redirect',redirect.value)
            // 跳转页面或其他操作
            // router.push('/dashboard')
          } catch (error) {
            console.error('登录处理失败:', error)
          }


      
      }).catch(() => {
        loading.value = false
        // 重新获取验证码
        if (captchaEnabled.value) {
          // getCode()
        }
      })
    }
  })
}
function transformRoutes(originalRoutes) {
  return originalRoutes.map(route => {
     const hasChildren = route.submenu && route.submenu.length > 0
    // 基础转换 - 所有路由都使用Layout作为父组件
    const transformedRoute = {
      path: route.url,
      name: route.menuname.replace(/\s+/g, '')+ new Date().getTime(),
      hidden: false,
      type: route.type,
      component: 'Layout', // 所有路由都使用Layout
      redirect: 'noRedirect',
      meta: {
        title: route.menuname,
        icon: route.icon,
        noCache: false,
        link: null,
         singleLevel: !hasChildren 
      },
      children: [] // 初始化children数组
    };

    // 处理有子路由的情况
    if (hasChildren) {
      transformedRoute.alwaysShow = true
      transformedRoute.children = route.submenu.map(child => ({
        path: child.url.startsWith('/') ? child.url.substring(1) : child.url,
        name: child.menuname.replace(/\s+/g, ''),
        hidden: false,
        component:`${route.url.replace(/^\//, '')}/${child.url}/index`,
        meta: {
          title: child.menuname,
          icon: child.icon,
          noCache: false,
          link: null
        }
      }));
    } 
    // 处理没有子路由的情况 - 将自己作为唯一的子路由
    else {
      
      transformedRoute.children.push({
        path: '',
        name: `${route.menuname.replace(/\s+/g, '')}`,
        hidden: false,
        component: `${route.url.replace(/^\//, '')}/index`,
        meta: {
          title: route.menuname,
          icon: route.icon,
          noCache: false,
          link: null
        }
      });
    }

    // 添加alwaysShow属性给有子路由的项
    // if (transformedRoute.children && transformedRoute.children.length > 0) {
    //   transformedRoute.alwaysShow = true;
    // }
    // console.log('transformedRoute',transformedRoute)
    
    return transformedRoute;
  });
}

// // 使用示例
// const transformedRoutes = transformRoutes(originalRoutes);
// console.log(transformedRoutes);
function encryptPassword(plainPassword) {
  const sm4Config = {
    key: "GJstSK_YBD=gSOFT",
    mode: 'ecb',
    cipherType: 'base64'
  }
  const sm4 = new SM4(sm4Config)
  
  try {
    return sm4.encrypt(plainPassword)
  } catch (error) {
    console.error('加密失败:', error)
    throw new Error('密码加密处理失败')
  }
}

function getCode() {
  getCodeImg().then(res => {
    captchaEnabled.value = res.captchaEnabled === undefined ? true : res.captchaEnabled
    if (captchaEnabled.value) {
      codeUrl.value = "data:image/gif;base64," + res.img
      loginForm.value.uuid = res.uuid
    }
  })
}

function getCookie() {
  const username = Cookies.get("username")
  const password = Cookies.get("password")
  const rememberMe = Cookies.get("rememberMe")
  loginForm.value = {
    username: username === undefined ? loginForm.value.username : username,
    password: password === undefined ? loginForm.value.password : decrypt(password),
    rememberMe: rememberMe === undefined ? false : Boolean(rememberMe)
  }
}

// getCode()
// getCookie()
</script>

<style lang='scss' scoped>
.login {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  background-image: url("../assets/images/login-background.jpg");
  background-size: cover;
}
.title {
  margin: 0px auto 30px auto;
  text-align: center;
  color: #707070;
}

.login-form {
  border-radius: 6px;
  background: #ffffff;
  width: 400px;
  padding: 25px 25px 5px 25px;
  z-index: 1;
  .el-input {
    height: 40px;
    input {
      height: 40px;
    }
  }
  .input-icon {
    height: 39px;
    width: 14px;
    margin-left: 0px;
  }
}
.login-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}
.login-code {
  width: 33%;
  height: 40px;
  float: right;
  img {
    cursor: pointer;
    vertical-align: middle;
  }
}
.el-login-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}
.login-code-img {
  height: 40px;
  padding-left: 12px;
}
</style>
